SUBROUTINE solve_current(pi,vlag,betalevel,resid, pistar, v, x2, x1, mc, c, r, y, l, w)

USE model_parameters
USE wrapper_vars
USE wrapper_coef

IMPLICIT NONE

DOUBLE PRECISION, INTENT(IN) :: pi, vlag, betalevel
DOUBLE PRECISION, INTENT(OUT) :: resid, pistar, v, x2, x1, mc, c, r, y, l, w
DOUBLE PRECISION :: exp_x2, exp_x1, exp_c, mc_overidentified

DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: poly

EXTERNAL chebypol

ALLOCATE(poly(order+1))



! from .mod eq 10
pistar = ((1.d0-thetap*pi**(epsilonp-1.d0))/(1.d0-thetap))**(1.d0/(1.d0-epsilonp))

! from eq 11
v = thetap*pi**epsilonp*vlag+(1.d0-thetap)*pistar**(-epsilonp)


! construct variables implied by polynomial rules
CALL chebypol(v,order,vstart,vend,poly)


CALL constructpol(coef_c_forstate_ptr,poly,order,exp_c)
CALL constructpol(coef_x1_forstate_ptr,poly,order,exp_x1)
CALL constructpol(coef_x2_forstate_ptr,poly,order,exp_x2)


! from eq 6
x2 = pistar*(1.d0/(1.d0-sharegp)+thetap*betalevel*exp_x2)

! from eq 4
x1=(epsilonp-1.d0)/epsilonp*x2

! from eq 5
mc = (x1-thetap*betalevel*exp_x1)*(1.d0-sharegp)



! proceed by guess and verify
! use equations 1 and 8
c = ((exp_c)**(-1.d0)/betalevel/(rss* (pi/piss)**phipip * (1.d0/css)**phiyp))**(1.d0/(1.d0+phiyp))
r = rss*( (pi/piss)**phipip * (c/css)**phiyp )


!r = rss* (pi/piss)**phipip * (vlag/vss)**phiyp
!c = (exp_c)**(-1.d0)/betalevel/r




IF (r < 1.d0) THEN
r = 1.d0
c = (exp_c)**(-1.d0)/betalevel
END IF

y = c/(1.d0-sharegp)

l = v*y

w = psip*l**varthetap*c

mc_overidentified = w

resid = mc_overidentified-mc

DEALLOCATE(poly)

END SUBROUTINE solve_current
